/*
  Speelt de Nokia-ringtone via een piezo-luidspreker. 

  Code geschreven op 24 juni 2016 door Koen Vervloesem en Martijn Overman voor Reshift Digital https://reshift.nl/ 

  Deze software mag worden verspreid onder de bepalingen van de GNU General Public License https://www.gnu.org/
*/

const int piezoPin = 12;
const int switchPin = 2;
const int notes[] = {1318, 1174, 739, 830, 1108, 987, 587, 659, 987, 880, 554, 659, 880};
const int delays[] = {125, 125, 250, 250, 125, 125, 250, 250, 125, 125, 250, 250, 1000};
int switchstate = 0;

void setup() {
  pinMode(piezoPin, OUTPUT);
  pinMode(switchPin, INPUT);
}

void loop() {

  switchstate = digitalRead(switchPin);

  if (switchstate == HIGH) {
     for (int i = 0; i < sizeof(notes)/sizeof(int); i++) {
       tone(piezoPin, notes[i]);
       delay(delays[i]);
     }
  }
  else {
    noTone(piezoPin);
  }
}
